unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ValEdit, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TDoubleArray = array[0..400000] of Double;
  PDoubleArray = ^TDoubleArray;

function SplineInterpolate(T: Double; N: Integer; X, Y, Z: PDoubleArray): Double;
var
  I, J, K: Integer;
  D, H: Double;
begin
  I := 0;
  J := N - 1;

  while I < J do
  begin
    K := (I + J) div 2;
    if X[K] < T then I := K + 1 else J := K;
  end;
  if I > 0 then I := I - 1;
  H := X[I +1] - X[I];
  D := T - X[I];

  Result := (((Z[I + 1] - Z[I]) * D / H + Z[i] * 3) * D
            + ((Y[I + 1] - y[I]) / H
            - (Z[I] * 2 + Z[I + 1]) * H)) * D + Y[I];
end;

procedure CalculateSplineTable(N: Integer; X, Y, Z: PDoubleArray);
var
  I: Integer;
  T: Double;
  H, D: PDoubleArray;
begin
  GetMem(H, SizeOf(Double) * N);
  GetMem(D, SizeOf(Double) * N);
  Z[0] := 0;
  Z[N - 1] := 0;
  for I := 0 to N - 2 do
  begin
    H[I] := X[I + 1] - X[I];
    D[I + 1] := (Y[I + 1] - Y[I]) / H[I];
  end;
  Z[1] := D[2] - D[1] - H[0] * Z[0];
  D[1] := 2 * (X[2] - X[0]);
  for I := 1 to N - 3 do
  begin
    T := H[I] / D[I];
    Z[I + 1] := D[I + 2] - D[I + 1] - Z[I] * T;
    D[I + 1] := 2 * (X[I + 2] - X[I]) - H[I] * T;
  end;
  Z[N - 2] := Z[N - 2] - H[N - 2] * Z[N - 1];
  for I := N - 2 downto 1 do
  begin
    Z[I] := (Z[I] - H[I] * Z[I + 1]) / D[I];
  end;
  FreeMem(D);
  FreeMem(H);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  N, I, J: Integer;
  X, Y, Z: PDoubleArray;
  S: string;
begin
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.FillRect(Image1.ClientRect);

  GetMem(X, SizeOf(Double) * Memo1.Lines.Count);
  GetMem(Y, SizeOf(Double) * Memo1.Lines.Count);
  GetMem(Z, SizeOf(Double) * Memo1.Lines.Count);

  N := 0;
  for I := 0 to 255 do
  begin
    S := Memo1.Lines.Values[IntToStr(I)];
    if S <> '' then
    begin
      X[N] := I;
      Y[N] := StrToInt(S);
      N := N + 1;
    end;
  end;
  CalculateSplineTable(N, X, Y, Z);

  for I := 0 to 255 do
  begin
    J := Trunc(SplineInterpolate(I, N, X, Y, Z) + 0.5);
    if J < 0 then J := 0 else if J > 255 then J := 255;
    J := 255 - J;
    Image1.Canvas.Pixels[I, J] := clBlack;
  end;

  FreeMem(Z);
  FreeMem(Y);
  FreeMem(X);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Button1Click(nil);
end;

end.
